﻿601,100
562,"NULL"
586,
585,
564,
565,"bhafB=rk^JNC?tomOvS[rx3svQkA[4]`eytxPvDnUT9l]U\50vBM^rP^[6XS>UIC9FOMFPN0zNmzf@G4;eCg=5hn3HUvWVR@EOibB^VFS@h1o63?kq26b0PsN0DmRDbhLnorbdZtnOMQoL\a=>E0\Zy67_X;:DHO_gcan>SRBpO8zemYVH=\n6R^@tOcg0ulXxDF0iNA"
559,1
928,0
593,
594,
595,
597,
598,
596,
800,
801,
566,0
567,","
588,"."
589,
568,""""
570,
571,
569,0
592,0
599,1000
560,6
pExecutionId
pAppId
pNode
pOwnerID
pTime
pControl
561,6
2
2
2
2
2
2
590,6
pExecutionId,"None"
pAppId,"None"
pNode,"None"
pOwnerID,"None"
pTime,"0"
pControl,"Y"
637,6
pExecutionId,
pAppId,
pNode,
pOwnerID,
pTime,
pControl,
577,0
578,0
579,0
580,0
581,0
582,0
572,158


#################################################################
## IBM Confidential
##
## OCO Source Materials
##
## BI and PM: pmpsvc
##
## (C) Copyright IBM Corp. 2010
##
## The source code for this program is not published or otherwise
## divested of its trade secrets, irrespective of what has been
## deposited with the U.S. Copyright Office.
#################################################################



cControlPrefix = '';
If (pControl @= 'Y');
cControlPrefix = '}';
EndIf;

#*** Log File Name
cTM1Process = GetProcessName();
StringGlobalVariable('gPrologLog');
StringGlobalVariable('gEpilogLog');
vReturnValue = ExecuteProcess(cControlPrefix | 'tp_get_log_file_names', 'pExecutionId', pExecutionId,
'pProcess', cTM1Process, 'pControl', pControl);
If (vReturnValue <> ProcessExitNormal());
ProcessError;
EndIf;
cPrologLog = gPrologLog;
cEpilogLog = gEpilogLog;
cTM1Log = cPrologLog;

cConfigDim = cControlPrefix | 'tp_config';
If (DimensionExists(cConfigDim) = 1);
cGenerateLog = ATTRS(cConfigDim, 'Generate TI Log', 'String Value');
Else;
cGenerateLog = 'N';
EndIf;

#*** Log Parameters
If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW,'\Y \M \d - \h:\i:\s'),
'Parameters:', pExecutionId, pAppId, pNode, pOwnerID, pControl);
EndIf;

#***

cStateCube = cControlPrefix | 'tp_application_state}' | pAppId;
cStateChangeDate = 'StateChangeDate';

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, 'Check state cube: ' | cStateCube);
EndIf;

If(CubeExists(cStateCube) = 0);
ProcessError;
EndIf;

#***

StringGlobalVariable('gApprovalDim');
StringGlobalVariable('gApprovalSubset');
StringGlobalVariable('gIsActive');

vReturnValue = ExecuteProcess(cControlPrefix | 'tp_get_application_attributes', 'pExecutionId', pExecutionId,
'pAppId', pAppId, 'pControl',  pControl);
If (vReturnValue <> ProcessExitNormal());
ProcessError;
EndIf;

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, 'get application attributes', gApprovalDim, gApprovalSubset, gIsActive);
EndIf;

#***

vNodePName = DimensionElementPrincipalName(gApprovalDim, pNode);
vOwnerPName = DimensionElementPrincipalName('}Clients', pOwnerId);
StringGlobalVariable('gMdxFindConsolidateDescendants');
vReturnValue = ExecuteProcess(cControlPrefix | 'tp_mdx_find_consolidate_descendants', 'pExecutionId', pExecutionId,
'pDim', gApprovalDim, 'pSubset',  gApprovalSubset, 'pNode',vNodePName  );
If (vReturnValue <> ProcessExitNormal());
ProcessError;
EndIf;

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, 'mdx: ' | gMdxFindConsolidateDescendants);
EndIf;

vSubset = 'ConNodesToOwn' | '_' | pExecutionId;
IF (SubsetExists(gApprovalDim, vSubset) <>0);
SubsetDestroy(gApprovalDim, vSubset);
ENDIF;
SubsetCreateByMdx(vSubset, gMdxFindConsolidateDescendants);

vReturnValue = ExecuteProcess(cControlPrefix | 'tp_util_convert_dynamic_subset_to_static', 'pExecutionId', pExecutionId,
'pDim', gApprovalDim, 'pSubset', vSubset);
If (vReturnValue <> ProcessExitNormal());
ProcessError;
EndIf;

vSize = SubsetGetSize(gApprovalDim, vSubset);

looper = vSize;
While (looper >=1);
vNode = SubsetGetElementName(gApprovalDim, vSubset, looper);

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, 'Check user privilege');
EndIf;

StringGlobalVariable('gView');
vReturnValue = ExecuteProcess(cControlPrefix | 'tp_get_user_permissions',
'pGuid', pExecutionId, 'pApplication', pAppId, 'pNode', vNode, 'pUser', pOwnerId , 'pControl', pControl);
If (vReturnValue <> ProcessExitNormal());
ProcessError;
EndIf;

If (gView @= 'T' & DType(gApprovalDim, vNode) @='C');
vOwnerGroup = cControlPrefix | 'tp_owner_' | gApprovalDim | '_' | vNode;

If (DIMIX('}Groups', vOwnerGroup) = 0);
vReturnValue = ExecuteProcess(cControlPrefix | 'tp_error_update_error_cube',
'pGuid', pExecutionId,
'pProcess', cTM1Process,
'pErrorCode', 'TI_NODE_NOT_EXIST',
'pErrorDetails', '}Groups' | ', ' | vOwnerGroup,
'pControl', pControl);

ProcessError;
EndIf;

AssignClientToGroup(vOwnerPName, vOwnerGroup);

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, 'Assign ' | vOwnerPName | ' into group: ' |  vOwnerGroup);
EndIf;

CellPutS(pTime, cStateCube, vNode, cStateChangeDate);

Endif;

looper = looper -1;
End;


#*** No error

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, 'The end has been reached.');
EndIf;



573,1

574,1

575,20


#################################################################
## IBM Confidential
##
## OCO Source Materials
##
## BI and PM: pmpsvc
##
## (C) Copyright IBM Corp. 2010
##
## The source code for this program is not published or otherwise
## divested of its trade secrets, irrespective of what has been
## deposited with the U.S. Copyright Office.
#################################################################


IF (SubsetExists(gApprovalDim, vSubset) <>0);
SubsetDestroy(gApprovalDim, vSubset);
ENDIF;
576,
638,1
804,0
1217,1
900,
901,
902,
903,
906,
929,
907,
908,
904,0
905,0
909,0
911,
912,
913,
914,
915,
916,
917,0
918,1
919,0
920,50000
921,""
922,""
923,0
924,""
925,""
926,""
927,""
